/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.google.code.p.narcissus.ui.components;

import java.awt.AlphaComposite;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Rectangle;

import com.google.code.p.narcissus.core.model.ReferenceMetaData;

/**
 *
 * @author jadoj
 */
public class ReferenceImagePanel extends ImagePanel {

    private ReferenceMetaData metaData;

    public void setMetaData(ReferenceMetaData metaData) {
        this.metaData = metaData;
        this.repaint();
    }

    @Override
    public void paintComponent(Graphics g) {
        super.paintComponent(g);
        Graphics2D graph = (Graphics2D) g;
        graph.setComposite(AlphaComposite.getInstance(AlphaComposite.SRC_OVER, 0.3f));

        if (this.metaData != null) {
            for (Rectangle currentExclusionZone : metaData.getExclusionZones()) {

                g.setColor(Color.DARK_GRAY);
                final int x = ((Double) currentExclusionZone.getX()).intValue();
                final int y = ((Double) currentExclusionZone.getY()).intValue();
                final int width = ((Double) currentExclusionZone.getWidth()).intValue();
                final int height = ((Double) currentExclusionZone.getHeight()).intValue();
                graph.fillRect(getScaledValue(x), getScaledValue(y), getScaledValue(width), getScaledValue(height));

                g.setColor(Color.GREEN);
                graph.drawRect(getScaledValue(x), getScaledValue(y), getScaledValue(width), getScaledValue(height));
            }
        }
    }
}
